{-|
Module      : Star
Description : Defines the Star backdrop object
Copyright   : (c) Christopher Howard, 2016
License     : GPL-3
Maintainer  : ch.howard@zoho.com
-}

module Star where

import Prelude ()
import Data.WrapAround (WP)
import Graphics.Gloss.Data.Picture (rectangleSolid, Picture(..))
import Graphics.Gloss.Data.Color (Color)

import Animation
import Moving

data Star = Star { location :: WP
                 , color :: Color
                 }

instance Animation Star where
  image star _ = Color (Star.color star) (rectangleSolid 1.0 1.0)

instance Locatable Star where
  center = location

